#pragma Library( "XppUI2.LIB" )                  // XbpQuickBrowse()
#pragma Library( "Adac20b.lib" )                 // DacPagedDataStore()

#include "Appevent.ch"
#include "DIRECTRY.CH"
#include "DBSTRUCT.CH"

STATIC aAllFiles := {}                           // result

PROCEDURE MAIN
LOCAL nEvent, mp1, mp2, oXbp
LOCAL i,iMax
LOCAL aSize
LOCAL cMask    := "*.PRG"
LOCAL aHeader  := {"File name"}


   DirEval( "C:\ALASKA\", "*.*", { | x, y | EvalEachFile( x, y , cMask) } )

   SET ALTER TO RESULT.TXT
   SET ALTER ON

   iMax := LEN(aAllFiles)
   FOR i := 1 TO iMax
      ? aAllFiles[i][ F_NAME ]
   NEXT

   SET ALTER OFF
   SET ALTER TO

   //
   // GUI Part to show
   //
   aSize := SetAppWindow():CurrentSize()
   aSize[1] -= 10
   aSize[2] -= 32

   oXbp := XbpQuickBrowse():new(,,, aSize )
   oXbp:dataLink := DacPagedDataStore():new( aAllFiles )
   oXbp:create()
   oXbp:setHeader( aHeader )
   oXbp:setColWidth(aSize[1],1)

   SetAppFocus( oXbp )

   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

PROCEDURE DirEval( cWorkPath, cMask, bBlock )
LOCAL aDIR
LOCAL nLEN
LOCAL nCount

   aDIR := DIRECTORY( cWorkPath + "*.*", "D" )
   nLEN := LEN( aDIR )

   FOR nCount := 1 TO nLEN
      IF "D" $ aDIR[ nCount, F_ATTR ] .AND. .NOT. ;
             ( aDIR[ nCount, F_NAME ] = "." .OR. ;
               aDIR[ nCount, F_NAME ] = ".." )

         DirEval( cWorkPath + aDIR[ nCount, F_NAME ] + "\", cMask, bBlock )
      ELSE
         EVAL( bBlock, cWorkPath, aDIR[ nCount, F_NAME ] )
      ENDIF
   NEXT

RETURN

FUNCTION EvalEachFile( ccPath, ccFile, cMask )

   IF "*." $ cMask
      cMask := StrTran(cMask,"*.",".")
   ENDIF

   IF UPPER(cMask) $ UPPER(ccFile)
      // only add Path and F_NAME
      AADD(aAllFiles,{ccPath+ccFile})
   ENDIF

RETURN NIL


*
*
*